var contextMenu = {

	_clickCallback : null,
	menuDiv : null,
	
	_menuItemClicked : function(target) {
		if (contextMenu._clickCallback && !target.disabled) {
			contextMenu._clickCallback(target.id);
		}
		
		contextMenu._clickCallback = null;
		document.getElementById("rootDiv").onclick = null;
		document.onkeyup = null;
		contextMenu.menuDiv.style.display = "none";
	},

	showContextMenu : function(menuDiv, x, y, clickCallback, itemEnableCallback) {
	
		//update items
		contextMenu.menuDiv = document.getElementById(menuDiv);
		var menuItems = contextMenu.menuDiv.children.item(0).children;
		for (i=0;i<menuItems.length;i++) {
		
			var enabled = true;
			if (itemEnableCallback) {
				enabled = itemEnableCallback(menuItems.item(i).id);
			}
		
			if (!enabled) {
				menuItems.item(i).style.color = "#DDDDDD";
				menuItems.item(i).disabled = true;
			} else {
				menuItems.item(i).style.color = null;
				menuItems.item(i).disabled = null;
			}
			
			menuItems.item(i).onclick = function(event) {
				contextMenu._menuItemClicked(event.target);
			};
		}
	
	
		//rest
		contextMenu.menuDiv.style.display = "block";
		contextMenu.menuDiv.style.left = x+"px";
		contextMenu.menuDiv.style.top = y+"px";
		contextMenu._clickCallback = clickCallback;
		
		document.getElementById("rootDiv").onclick=function(event) {
			contextMenu._clickCallback = null;
			document.getElementById("rootDiv").onclick = null;
			document.onkeyup = null;
			contextMenu.menuDiv.style.display = "none";
		};
		
		document.onkeyup=function(e) {
			if (e.keyCode==27) {
				contextMenu._clickCallback = null;
				document.getElementById("rootDiv").onclick = null;
				document.onkeyup = null;
				contextMenu.menuDiv.style.display = "none";
			}
		};
		
		event.preventDefault();
		event.stopImmediatePropagation();
	}
	
}